/*
# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image 
#                        pour la Santé)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
#
#  This software is governed by the CeCILL-B license under French law and 
#  abiding by the rules of distribution of free software. You can  use, 
#  modify and/ or redistribute the software under the terms of the CeCILL-B 
#  license as circulated by CEA, CNRS and INRIA at the following URL 
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability. 
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------  
*/

/*=========================================================================                                                                               
Program:   bbtk
Module:    $RCSfile$
Language:  C++
Date:      $Date$
Version:   $Revision$
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         


/****
* Design and Developpement of BBTK GEditor
* Ricardo A Corredor J <eduardo.davila@creatis.insa-lyon.fr>
* RaC - 2010
****/

#ifndef __ExecuterBBSG_h__
#define __ExecuterBBSG_h__

//Includes same project
#include "wxVtkSceneManager.h"

//Includes bbtk
#include "bbtkInterpreterVirtual.h"

//Includes std
#include <iostream>


//#include "bbtkSystem.h"
//#include "bbtkComplexBlackBox.h"
#include "bbtkFactory.h"

namespace bbtk
{
	class InterpreterBBS : public InterpreterVirtual
	{
		public:
		static Pointer New( wxVtkSceneManager* sceneManager, Factory::Pointer factory );
		InterpreterBBS( wxVtkSceneManager* sceneManager, Factory::Pointer factory );
		~InterpreterBBS();
		
		//Public methods

		virtual void commandNew( const std::string& boxType, const std::string& boxName);
		
		virtual void commandConnection (const std::string &boxfrom,
                                     const std::string &output,
                                     const std::string &boxto,
                                     const std::string &input);
		virtual void commandSet(const std::string &box,const std::string &input,const std::string &value);


		virtual void commandDefine(const std::string &name,const std::string &pack,const std::string &scriptfilename);
		virtual void commandEndDefine();
		
		virtual void commandExec(const std::string &word);
		
		virtual void commandAuthor(const std::string &author);
		virtual void commandCategory(const std::string &categorytype);
		virtual void commandDescription(const std::string &description);
		
		virtual void commandInput(const std::string &name,const std::string &box,const std::string &input,const std::string  &help);
		virtual void commandOutput(const std::string &name,const std::string &box,const std::string &output,const std::string  &help);


		double              _xGeneral;
		double              _yGeneral;
		double              _zGeneral;
		int					_countInputs;
		int					_countOutputs;
		int					_countBoxes;
		wxVtkSceneManager   *_sceneManager;
		Factory::Pointer    _factory;
		
	private:

		//Private Attributes

		//Private Methods

	protected:

		//Protected Attributes

		//Protected methods
		
	};
}
// namespace bbtk
#endif

